Description

History

#1 - 05/27/2022 10:18 AM - Eric Faulhaber

The following features need implementation/improvement:

DBPARAM builtin function - not all CONNECT params reported (but as long as we report all params we support, we are good; this has to stay up

to date with CONNECT statement support)

DBRESTRICTIONS builtin function is marked runtime stubs

RCODE-INFO TABLE-LIST attribute - just need to check if the conversion handles the legacy name correctly (case-sensitivity, etc)

#4 - 11/16/2022 12:29 PM - Eric Faulhaber

- Assignee set to Igor Skornyakov

#5 - 11/25/2022 12:51 PM - Igor Skornyakov

- Status changed from New to WIP

#6 - 11/27/2022 01:06 PM - Igor Skornyakov

As I can see from the code DBPARAM reports all parameters supported by FWD for CONNECT

It looks that the only database restriction we have to support is READ-ONLY. Should be reported if the database was opened with -RO option.

Not sure about SET-CURRENT-VALUE ("Cannot set the current value of sequence generators.").

Working on RCODE-INFO:TABLE-LIST.

#7 - 11/28/2022 02:49 AM - Constantin Asofiei

Igor, RCODE-INFO:TABLE-LIST is already added in 6129b.

#8 - 11/28/2022 09:18 AM - Igor Skornyakov

Constantin Asofiei wrote:

Igor, RCODE-INFO:TABLE-LIST is already added in 6129b.

 

Constantin,
I see only RcodeInfo interface in our code, however I understand that I have to check the functionality.

Where can I find a description of RCODE-INFO support in FWD. I understand that r-code has no counterpart in FWD.

Thank you.

#9 - 11/28/2022 09:59 AM - Constantin Asofiei

Igor Skornyakov wrote:

Constantin Asofiei wrote:

Igor, RCODE-INFO:TABLE-LIST is already added in 6129b.

 

Constantin,

I see only RcodeInfo interface in our code, however I understand that I have to check the functionality.

 

Look in the RcodeInfoOps.java file - this is a static proxy which implements the RcodeInfo interface.

#10 - 11/28/2022 10:04 AM - Igor Skornyakov

Constantin Asofiei wrote:

Igor Skornyakov wrote:

Constantin Asofiei wrote:

Igor, RCODE-INFO:TABLE-LIST is already added in 6129b.

 

Constantin,

I see only RcodeInfo interface in our code, however I understand that I have to check the functionality.

 

Look in the RcodeInfoOps.java file - this is a static proxy which implements the RcodeInfo interface.

 

Thank you!
#11 - 11/28/2022 11:37 AM - Igor Skornyakov

- File dbrestrictions.diff added

Igor Skornyakov wrote:

It looks that the only database restriction we have to support is READ-ONLY. Should be reported if the database was opened with -RO

option. Not sure about SET-CURRENT-VALUE According to my test only READ-ONLY can appear in the DBRESTRICTIONS result.

 

Reworked the DBRESTRICTIONS support. See the attached .diff file for 6129b/14334.

Please review.

Thank you.

#12 - 11/28/2022 12:23 PM - Igor Skornyakov

I've noticed the following problem.

The statement

  DISPLAY 

    RCODE-INFO:CRC-VALUE LABEL "CRC" 

    RCODE-INFO:DB-REFERENCES LABEL "DB-REFERENCES" 

    RCODE-INFO:TABLE-LIST LABEL "TABLE-LIST" 

    RCODE-INFO:LANGUAGES FORMAT "x(60)" LABEL "Languages" 

    WITH FRAME rc-info SIDE-LABELS TITLE "R-code Check".

 

Is compiled to

            FrameElement[] elementList1 = new FrameElement[]

            {

               new Element(, rcInfoFrame.widgetExpr2()),

               new Element(RcodeInfoOps.getDbReferences(), rcInfoFrame.widgetExpr3()),

               new Element(RcodeInfoOps.getTableList(), rcInfoFrame.widgetExpr4()),

               new Element(, rcInfoFrame.widgetExpr5())

            };

            rcInfoFrame.display(elementList1);

which does not compile.    

I understand that this is because we do not have even stubs for RCODE-INFO:CRC-VALUE and RCODE-INFO:LANGUAGES.

Does it make sense to add stubs for these (and other missing RCODE-INFO attributes) now?

Thank you.
#13 - 11/28/2022 02:30 PM - Igor Skornyakov

As far as I can see, RCODE-INFO:TABLE-LIST inplementation in FWD uses the value of the tables attribute of the @DatabaseReferences

annotation. So the question is about this annotation.

Strangely enough I have found no @DatabaseReferences annotation in a converted large customer application (a pretty old version) with non-empty

tables attribute. However, in my test this attribute exists and looks OK.

#14 - 11/28/2022 02:50 PM - Greg Shah

I understand that this is because we do not have even stubs for RCODE-INFO:CRC-VALUE and RCODE-INFO:LANGUAGES.

Does it make sense to add stubs for these (and other missing RCODE-INFO attributes) now?

 

Yes, please do.  Make sure to update the gap analysis too.

#15 - 11/28/2022 02:52 PM - Igor Skornyakov

Greg Shah wrote:

I understand that this is because we do not have even stubs for RCODE-INFO:CRC-VALUE and RCODE-INFO:LANGUAGES.

Does it make sense to add stubs for these (and other missing RCODE-INFO attributes) now?

 

Yes, please do.  Make sure to update the gap analysis too.

 

OK, thank you.

#16 - 11/29/2022 03:09 AM - Constantin Asofiei

Igor Skornyakov wrote:

Strangely enough I have found no @DatabaseReferences annotation in a converted large customer application (a pretty old version) with

non-empty tables attribute.

 

The conversion needs to be with 6129b for tables attribute to be populated.
#17 - 11/29/2022 04:24 AM - Igor Skornyakov

Constantin Asofiei wrote:

Igor Skornyakov wrote:

Strangely enough I have found no @DatabaseReferences annotation in a converted large customer application (a pretty old version) with

non-empty tables attribute.

 

The conversion needs to be with 6129b for tables attribute to be populated.

 

Oh, I see. Thank you!

#18 - 11/29/2022 07:50 AM - Igor Skornyakov

Greg Shah wrote:

I understand that this is because we do not have even stubs for RCODE-INFO:CRC-VALUE and RCODE-INFO:LANGUAGES.

Does it make sense to add stubs for these (and other missing RCODE-INFO attributes) now?

 

Yes, please do.  Make sure to update the gap analysis too.

 

Added stubs for missed RCODE-INFO attributes.

Committed to 6129b/14335.

#19 - 11/30/2022 02:04 AM - Eric Faulhaber

Igor, other than requiring review for the patch in #6454-11 and for 6129b/14335, is this task finished from your point of view? Have the changes been

tested? If so, please mark it 100% and status "Review". Thanks.

#20 - 11/30/2022 02:18 AM - Igor Skornyakov
- Status changed from WIP to Review

- % Done changed from 0 to 100

Eric Faulhaber wrote:

Igor, other than requiring review for the patch in #6454-11 and for 6129b/14335, is this task finished from your point of view? Have the changes

been tested? If so, please mark it 100% and status "Review". Thanks.

 

Eric,

Yes, I think that the only remaining think is reviewing #6454-11. I've tested the changes.

#21 - 01/06/2023 12:37 AM - Eric Faulhaber

Igor Skornyakov wrote:

Eric Faulhaber wrote:

Igor, other than requiring review for the patch in #6454-11 and for 6129b/14335, is this task finished from your point of view? Have the

changes been tested? If so, please mark it 100% and status "Review". Thanks.

 

Eric,

Yes, I think that the only remaining think is reviewing #6454-11. I've tested the changes.

 

The changes in dbrestrictions.diff look good. Please commit it to 6129b. 6129b/14335 also looks good.

#22 - 01/06/2023 02:28 AM - Igor Skornyakov

Eric Faulhaber wrote:

The changes in dbrestrictions.diff look good. Please commit it to 6129b. 6129b/14335 also looks good.

 

Committed to 6129b/14342.
Files

dbrestrictions.diff 5.18 KB 11/28/2022 Igor Skornyakov
